; Saves_all_layers_to_separate_pat_files.scm
;
; origine http://groups.google.ca/group/comp.graphics.apps.gimp/browse_thread/thread/010e01bd0930438a#
; modification pour enregistrer en .pat (motifs Gimp)
; fonctionne Gimp 2.6.1 Windows
;
(define (script-fu-save-layers-to-pat-files image dont-ask display-images short-description-of-the-pattern)
(let ((basename (car (gimp-image-get-filename image))))
(when (string=? basename "")
(set! basename (string-append
(car (gimp-temp-name ""))
(car (gimp-image-get-name image)))))
(let loop ((layers (vector->list (cadr (gimp-image-get-layers image)))))
(unless (null? layers)
(gimp-edit-copy (car layers))

(let ((img (car (gimp-edit-paste-as-new)))
(new-name (string-append
basename
(car (gimp-drawable-get-name (car layers)))
".pat")))
(file-pat-save dont-ask img (aref (cadr (gimp-image-get-layers img)) 0) new-name new-name short-description-of-the-pattern)
(if (= FALSE display-images)
;; clean up afterwards if we are not going to
;; display the images anyway:
(gimp-image-delete img)
(gimp-display-new img)))
(loop (cdr layers))))))

(script-fu-register "script-fu-save-layers-to-pat-files"
; modif samj _"Save all layers to a different file"
_"Save layers to pat (Motifs Gimp)..."
_"Saves all layers to separate .pat files"
"Niels Giesen (niels.gie...@gmail.com) - samj"
"Niels Giesen - samj"
"2008-10-29"
""
SF-IMAGE "Image" 1
SF-TOGGLE _"Don't ask options for each layer" TRUE
SF-TOGGLE _"Display images?" FALSE
SF-STRING "Description sommaire des motifs" "Motifs issus de calques")

(script-fu-menu-register "script-fu-save-layers-to-pat-files"
; modif samj _"<Image>/File")
_"<Image>/File")
